///////////////////////////////////////////////////////////////////////
// Nom Unite: U_SeleArticle
// Description : Gestion des articles
// Cr?? par Microcelt
// Modifi? le 09/05/05 : ajout de l'onglet "Composition" pour avoir une vision
//     de la omposition de l'article quand celui-ci a la case "A composer" est coch?e
// 26/05/05 : - En tant qu'assistante, la creation d'articles speciaux est possible
//     et suppression d'article impossible et uniquement la modif des speciaux
//    - boutons tout deplacement de l'onglet 'Declassement des articles" non visible
//    - ajout du bouton Copie
// Ne pas renseigner les ?v?nements AfterScroll non dico ? cause du mode asynchrone
///////////////////////////////////////////////////////////////////////
unit U_SeleArticle;

{$IFDEF FPC}
  {$MODE Delphi}
{$ENDIF}

interface

uses
{$IFNDEF FPC}
  RXSplit, UltimDBGrid, RbSplitter, JvEdit, JvRadioButton, AdvListV, JvExStdCtrls, Mask,
{$ELSE}
  MaskEdit,
{$ENDIF}
  LCLType, Messages, Graphics, Controls, Classes, ExtCtrls,
  Dialogs, DB, IBQuery,IBTable,IBUpdateSQL,
  U_ExtDBNavigator, Buttons, Forms, DBCtrls, Grids,
  DBGrids, u_framework_dbcomponents, ComCtrls, StdCtrls, SysUtils,
  TypInfo, Variants, StrUtils, ToolEdit, U_OnFormInfoIni,
  ExtJvXPButtons,U_FormMainIni,u_framework_components,
  u_buttons_appli, U_FormDico,
  U_ExtDBGrid,U_ConstMessage, VirtualTrees, ImgList, VirtualDBTreeEx,
  U_GroupView, fonctions_dbcomponents;

const
  CST_ARTI_Compose = 'ARTI_Compose' ;

  CST_ARFI_Choixfinit = 'ARFI_Choixfinit' ;
  CST_ARFI__TYFI      = 'ARFI__TYFI' ;
  CST_ARFI__FINI      = 'ARFI__FINI' ;
  CST_ARTI_Date        = 'ARTI_Datecrea';
  CST_ARTI_Clep        = 'ARTI_Clep';


type

  { TF_SeleArticle }

  TF_SeleArticle = class(TF_FormDico)
    ed_coefpoids: TFWDBEdit;
    ed_cubage: TFWDBEdit;
    ed_Poids: TFWDBEdit;
    ed_pxactu: TFWDBEdit;
    ed_pxfutur: TFWDBEdit;
    gbx_prix: TGroupBox;
    Label20: TFWLabel;
    lb_cubage: TFWLabel;
    lb_poids: TFWLabel;
    lb_pxactu: TFWLabel;
    lb_pxfutur: TFWLabel;
    nv_navigator: TExtDBNavigator;
    Pa_chiffres: TPanel;
    pa_1: TPanel;
    pa_2: TPanel;
    pa_4: TPanel;
    SvgFormInfoIni: TOnFormInfoIni;
    Rb_1: TSplitter;
    gd_article: TExtDBGrid;
    pa_3: TPanel;
    pc_art: TPageControl;
    tb_chiffre: TTabSheet;
    pa_Saisie: TPanel;
    lb_codearti: TFWLabel;
    lb_codecommarti: TFWLabel;
    lb_datecrea: TFWLabel;
    ed_codearti: TFWDBEdit;
    ed_codecommarti: TFWDBEdit;
    RbSplitter2: TSplitter;
    im_Liste1: TImageList;
    DBText1: TDBText;
    chx_acomposer: TDBCheckBox;
    Label14: TFWLabel;
    ts_Compose: TTabSheet;
    Panel12: TPanel;
    lsv_Composein: TDBGroupView;
    Panel14: TPanel;
    bt_in_item: TFWInSelect;
    bt_in_total: TFWInAll;
    bt_out_item: TFWOutSelect;
    bt_out_total: TFWOutAll;
    lsv_BrOut: TDBGroupView;
    Panel15: TPanel;
    Panel16: TPanel;
    Panel17: TPanel;
    Panel18: TPanel;
    Panel19: TPanel;
    bt_abandonner: TFWCancel;
    bt_enregistrer: TFWOK;
    bt_TypePro: TJvXpButton;
    DBLookupComboBox2: TDBLookupComboBox;
    Label17: TFWLabel;
    Label15: TFWLabel;
    DBLookupComboBox4: TDBLookupComboBox;
    DBLookupComboBox3: TDBLookupComboBox;
    lb_acomposer: TFWLabel;
    ed_FiltreBranches: TEdit;
    Label6: TFWLabel;
    im_images: TImageList;
    RbSplitter3: TSplitter;
    mo_libcom: TDBMemo;
    lb_des: TFWLabel;
    lb_declasse: TFWLabel;
    chx_declasse: TDBCheckBox;
    pa_5: TPanel;
    nv_saisie: TExtDBNavigator;
    Panel5: TPanel;
    Panel20: TPanel;
    bt_apercu: TFWPreview;
    Panel21: TPanel;
    bt_imprimer: TFWPrint;
    Panel22: TPanel;
    Panel23: TPanel;
    bt_fermer: TFWClose;
    lb_special: TFWLabel;
    chx_special: TDBCheckBox;
    ts_composition: TTabSheet;
    vt_Composition: TCheckVirtualDBTreeEx;
    bt_copieart: TFWCopy;
    procedure cbx_TypeProduitChange(Sender: TObject);
    procedure F_FormDicoCreate(Sender: TObject);
    procedure bt_fermerClick(Sender: TObject);

    procedure pc_artChange(Sender: TObject);
    procedure pc_artChanging(Sender: TObject; var AllowChange: Boolean);
    procedure gd_articleDblClick(Sender: TObject);
    procedure nv_seleBtnSearch(Sender: TObject);
    procedure F_FormDicoClose(Sender: TObject; var Action: TCloseAction);
    procedure ComboBox1Click(Sender: TObject);
    procedure ed_codeartiClick(Sender: TObject);
    procedure F_FormDicoDestroy(Sender: TObject);
    procedure cbx_CaracteristiqueClick(Sender: TObject);
    procedure cbx_GammeClick(Sender: TObject);
    procedure F_FormDicoDataDBSourcescroll(DataSet: TDataSet);
    procedure F_FormDicoShow(Sender: TObject);
    procedure bt_TypeProClick(Sender: TObject);
    procedure ed_FiltreBranchesKeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure lsv_ArticleInDBOnRecorded(DataSet: TDataSet);
    procedure vt_CompositionBeforeCellPaint(Sender: TBaseVirtualTree;
      TargetCanvas: TCanvas; Node: PVirtualNode; Column: TColumnIndex;
      CellRect: TRect);
    procedure bt_copieartClick(Sender: TObject);
    procedure F_FormDicoOnEraseFilter(const Dataset: TDataSet;
      const as_Champ: String);
    procedure F_FormDicoDataSearching(const Dataset: TDataSet;
      const as_Champ: String);
    procedure F_FormDicoDataOnSort(Dataset: TDataSet; as_Champ,
      as_TypeTri: String);
  private
    { D?clarations priv?es }
    gts_activepage: TTabSheet;
    ls_LabelFinition : WideString ;
    procedure p_Copiearticle(as_newcode : string);
    procedure p_EffaceOrderBy(const adat_MainQuery: TIBQuery);

  public
    { D?clarations publiques }
    procedure p_initInsert;
    procedure Loaded; override;
//    procedure p_initDBSources[1].Datasource;
  end;

var
  F_SeleArticle: TF_SeleArticle;
  gb_ArticleappeleParDevis : boolean = False ;

implementation
uses U_Structure, fonctions_string,
     U_DmCompose, unite_messages,
     fonctions_forms,
     fonctions_erreurs,fonctions_db,
     U_ComposeArticle,
     U_DmArticle, U_DmDonn;

{$IFNDEF FPC}
  {$R *.dfm}
{$ELSE}
  {$R *.lfm}
{$ENDIF}
procedure TF_SeleArticle.F_FormDicoCreate(Sender: TObject);
begin
  F_SeleArticle := Self;
  {
  p_AffecteEvenementsDatasetPrincipal ( M_Article.zq_Article1 );
  p_AffecteEvenementsDatasetPrincipal ( M_Article.zq_Article2 );
  p_AffecteEvenementsDatasetPrincipal ( M_Article.zq_Article3 );
  p_AffecteEvenementsDatasetPrincipal ( M_Article.zq_Article4 );
  p_AffecteEvenementsDatasetPrincipal ( M_Article.zq_Article5 );
  p_AffecteEvenementsDatasetPrincipal ( M_Article.zq_Article6 );}

//  ct_art.ActivePageIndex := 0;

  gts_activepage := pc_art.ActivePage;

////////////////////////////////////////////////////////////////////////////////
 ///////////////////////////////////////////////////////////////////////////////
end;

procedure TF_SeleArticle.cbx_TypeProduitChange(Sender: TObject);
begin

end;

procedure TF_SeleArticle.bt_fermerClick(Sender: TObject);
begin
  close;
  M_Article.ds_article.DataSet.Filtered := False;
  M_Article.ds_article.DataSet.Filter := '';
end;

procedure TF_SeleArticle.pc_artChange(Sender: TObject);
//var li_Choix : Integer ;
begin
  // Impossible de changer d'onglet quand on est en modif
  if ( pc_art.ActivePage = ts_Compose  ) Then
    try
      if gd_article.Datasource.DataSet.State in [ dsInsert, dsEdit ] Then
        gd_article.Datasource.DataSet.Post ;
    Except
      on e: Exception do
        Begin
          pc_art.ActivePage := gts_activepage ;
          f_GereException( e, gd_article.Datasource.DataSet );
        End ;
    End; 
end;

procedure TF_SeleArticle.pc_artChanging(Sender: TObject;
  var AllowChange: Boolean);
//var li_Choix : Integer ;
begin
  gts_activepage := (Sender as TPageControl).ActivePage;
  if ( gts_activepage = ts_Compose )
  and bt_enregistrer.Enabled Then
    try
      bt_enregistrer.OnClick ( bt_enregistrer  );
    Except
      on e: Exception do
        Begin
          f_GereException ( e, gd_article.Datasource.DataSet );
          AllowChange := False ;
        End ;
    End;
end;

procedure TF_SeleArticle.gd_articleDblClick(Sender: TObject);
begin
  if gd_article.Datasource.DataSet.FieldByName ( 'ARTI_Compose' ).AsBoolean Then
    Begin
//      M_DmCompose.zq_BranInArt.Close ;
  //    M_DmCompose.zq_BranInArt.Params.FindParam ( 'groupe' ).Value := gd_article.Datasource.DataSet.FieldByName ( 'ARTI_Clep' ).Value ;
    //  M_DmCompose.zq_BranInArt.Open ;
    End ;

  if Self.FormStyle = fsNormal then
    if gd_article.Datasource.DataSet.FieldByName ( 'ARTI_Compose' ).AsBoolean
//    and not M_DmCompose.zq_BranInArt.IsEmpty
     Then
      Begin
        if assigned ( F_ComposeArticle )
        and F_ComposeArticle.Visible Then
          F_ComposeArticle.Close ;
        fp_CreateUniqueChild ( TF_ComposeArticle, fsMDIChild );
        if assigned ( F_ComposeArticle ) Then
          Begin
            M_DmCompose.zq_ArbreArt.Close ;
            M_DmCompose.zq_ArbreArt.Params.FindParam ( 'ArticleC' ).Value := M_Article.ds_article.DataSet.FieldByName ( 'ARTI_Clep' ).Value ;
            M_DmCompose.zq_ArbreArt.Open ;
            F_ComposeArticle.gb_Simule := False ;
            F_ComposeArticle.ShowModal ;
            Self.Close;
          End ;
      End
    Else
      begin
       //  gb_valide     := True;
       //  gs_CodePostal := ed_code.Text;
       //  gs_Ville      := ed_ville.Text;
        Self.Close;
        //Self.Visible := False;
        //F_Devis.Show;
      end;  

end;

procedure TF_SeleArticle.nv_seleBtnSearch(Sender: TObject);
var lvar_CleArticle : Variant ;
    filtre : string;
begin
  if gd_article.Datasource.DataSet.State in [ dsInsert, dsEdit ] Then
    Exit ;
  try
    if gd_article.Datasource.Dataset.IsEmpty Then
      lvar_CleArticle := Null 
    Else
      lvar_CleArticle := gd_article.Datasource.Dataset.FieldByName ( CST_ARTI_Clep ).Value ;
   Except
    on e: Exception do
      f_GereException ( e, M_Article.ds_article.DataSet );
  End ;
// total
  M_Article.ds_article.DataSet.Open ;

  // selection
  filtre := '';

  If filtre <> '' then                                     {
    if ( M_Article.ds_article.DataSet as TCUstomADODAtaset ).CursorLocation = clUseClient Then
      Begin
        M_Article.ds_article.DataSet.Filter := filtre;
        M_Article.ds_article.DataSet.Filtered := True;
      End
    Else                                                    }
      Begin
        try
          if ( pos ( 'WHERE', UpperCase ( ( M_Article.ds_article.DataSet as TIBQuery ).SQL.Text )) > 0 ) Then
            ( M_Article.ds_article.DataSet as TIBQuery ).SQL.Add ( 'AND ' + filtre )
          Else
            ( M_Article.ds_article.DataSet as TIBQuery ).SQL.Add ( 'WHERE ' + filtre );
          M_Article.ds_article.DataSet.Open ;
        Except
          on e: Exception do
            f_GereException ( e, M_Article.ds_article.DataSet );
        End ;
      End ;

  try
    if lvar_CleArticle <> Null Then
      gd_article.Datasource.Dataset.Locate ( CST_ARTI_Clep, lvar_CleArticle, [] );
  Except
  End ;

end;

procedure TF_SeleArticle.F_FormDicoClose(Sender: TObject;
  var Action: TCloseAction);
begin
  {
  if ( M_Article.ds_article.DataSet as TCUstomADODAtaset ).CursorLocation = clUseServer Then
    Begin
      p_EffaceSelection ( M_Article.ds_article.DataSet as TIBQuery );
      M_Article.ds_article.DataSet.Open ;
    End ;}
  gb_ArticleappeleParDevis := false;
  M_Article.ds_article.DataSet.Filtered := False;
  M_Article.ds_article.DataSet.Filter   := '' ;
  Action := caHide ;
end;

procedure TF_SeleArticle.ComboBox1Click(Sender: TObject);
begin
gd_article.Enabled := False;

end;

procedure TF_SeleArticle.ed_codeartiClick(Sender: TObject);
begin
gd_article.Enabled := True;
end;

procedure TF_SeleArticle.F_FormDicoDestroy(Sender: TObject);
begin
  gb_ArticleappeleParDevis := false;
  F_SeleArticle := Nil ;
end;
//////////////////////////////////////////////////////////////////////////////
// Ev?nement : cbx_CaracteristiqueClick
// Description : Nouveau filtrage filtrage par Caract?ristique de produits
// Param?tres  : Sender : Le contr?le de l'?v?nement
//////////////////////////////////////////////////////////////////////////////
procedure TF_SeleArticle.cbx_CaracteristiqueClick(Sender: TObject);
begin
  nv_seleBtnSearch ( Sender );

end;

//////////////////////////////////////////////////////////////////////////////
// Ev?nement : cbx_GammeClick
// Description : Nouveau filtrage filtrage par Gamme de produits
// Param?tres  : Sender : Le contr?le de l'?v?nement
//////////////////////////////////////////////////////////////////////////////
procedure TF_SeleArticle.cbx_GammeClick(Sender: TObject);
begin
  nv_seleBtnSearch ( Sender );

end;

procedure TF_SeleArticle.F_FormDicoDataDBSourcescroll(DataSet: TDataSet);
begin
  // La form dico s'occupe de g?rer le gd_article.Datasource 2 via gd_article.DatasourceGridLookupField
//  p_initgd_artcoul.Datasource;
  // affichage de l'onglet "Composition" en fonction du profil
  ts_Composition.TabVisible := gd_article.Datasource.DataSet.FieldByName ( CST_ARTI_Compose ).AsBoolean;
//  ts_Compose.TabVisible := (( gi_niveau_priv = U_CST_ASSISTANT ) or ( gi_niveau_priv >= U_CST_CONTROLEGESTION )) and gd_article.Datasource.DataSet.Active and gd_article.Datasource.DataSet.FieldByName ( CST_ARTI_Compose ).AsBoolean ;
  if gd_article.Datasource.DataSet.FieldByName ( 'ARTI_Compose' ).AsBoolean then
    begin
      M_Article.zq_ArbreArt.Close ;
      M_Article.zq_ArbreArt.Params.ParamByName('ArticleC').Value := gd_article.Datasource.DataSet.FieldByName('ARTI_Clep').Value ;
      M_Article.zq_ArbreArt.Open ;

      // d?ploiement de l'arbre
      if vt_Composition.GetFirst <> nil Then
          vt_Composition.FullExpand ( vt_Composition.GetFirst );
    end;
end;

procedure TF_SeleArticle.F_FormDicoShow(Sender: TObject);
begin
  // reaffectation car pas de controfocus sur la form
  // a cause du forcage de la recherche
  if fsmodal in FFormState then
    pc_art.ActivePageIndex := 6;
end;

procedure TF_SeleArticle.bt_TypeProClick(Sender: TObject);
begin
  {// ne bouton na pas d'utilit?
  ffor_ExecuteFonction ( U_CST_TYPEPRODUIT, True );
  if ( lsv_Composein.Items.Count > 0 )
  and M_DmCompose.zq_Structure.Active Then
    if assigned ( lsv_Composein.Selected ) Then
      M_DmCompose.zq_Structure.Locate ( CST_STRU_Clep, lsv_Composein.Selected.Caption, [] )
    Else
      M_DmCompose.zq_Structure.Locate ( CST_STRU_Clep, lsv_Composein.Items [ 0 ].Caption, [] );
  }
end;

procedure TF_SeleArticle.ed_FiltreBranchesKeyUp(Sender: TObject;
  var Key: Word; Shift: TShiftState);
begin
  if ed_FiltreBranches.Text = '' Then
    lsv_BrOut.Datasource.DataSet.Filtered := False
  Else
    Begin
      lsv_BrOut.Datasource.DataSet.Filter := lsv_BrOut.DataKeyUnit + ' LIKE ''' + ed_FiltreBranches.Text + '%''' ;
      lsv_BrOut.Datasource.DataSet.Filtered := True ;
    End ;
  lsv_BrOut.Refresh ;

end;

procedure TF_SeleArticle.p_initInsert;
begin
  gd_article.Datasource.DataSet.FieldByName('ARTI_Declasse').Value := 0;
  gd_article.Datasource.DataSet.FieldByName('ARTI_Compose').Value := 0;
end;

procedure TF_SeleArticle.lsv_ArticleInDBOnRecorded(DataSet: TDataSet);
begin
  //Rafraichit le champ Declasse
  fb_RefreshDataset(DataSet);
end;

/////////////////////////////////////////////////////////////////////////////
// Ev?nement   : vt_CompositionBeforeCellPaint
// Description : Pr?sentation des noeuds de la composition
//                avec gestion de couleurs
// **** POSE UN PROBLEME SUR LE RAFRAICHISSEMENT DU EXRXDBGRID DES ARTICLES***/
/////////////////////////////////////////////////////////////////////////////
procedure TF_SeleArticle.vt_CompositionBeforeCellPaint(
  Sender: TBaseVirtualTree; TargetCanvas: TCanvas; Node: PVirtualNode;
  Column: TColumnIndex; CellRect: TRect);
//var
  //ldbn_DBData: PDBNodeData;
begin
  // On est sur le deuxi?me niveau ?
  // r?cup?ration des donn?es du noeud
  //ldbn_DBData := ( Sender as tBaseVirtualDbTreeEx ).GetDBNodeData( Node );

  {// **** PROBLEME DE RAFRAICHISSEMENT DU EXRXDBGRID ***/
   If //( ldbn_DBData.Cancheck ) and
    ( Node.CheckType <> ctNone ) then
     // On peut s?lectionner le noeud
      begin
    vt_Composition.Font.Color := clBlue ;
    vt_Composition.Font.Style := [fsBold]
    end
  else
     // On ne peut s?lectionner le noeud
    begin
    vt_Composition.Font.Color := clbLACK ;
    vt_Composition.Font.Style := []
    end;

  // Multi-s?lection ? valider ( les branches du dessous vont faire la s?lection et sont ? valider )
  If  ( Node.CheckType =  ctTristateCheckBox )
  and  ( Node.CheckState in [csMixedNormal, csMixedPressed]) then
      begin
      vt_Composition.NodeHeight [Node]:= 20;
      vt_Composition.Font.Size := 10;
      vt_Composition.Font.Color := clgreen ;
      vt_Composition.Font.Style := [fsBold]

      end else
      //  la font est ? r?initialiser sinon
        vt_Composition.Font.Size := 8;

  // Peinture en fonction du pinceau
  TargetCanvas.FillRect ( CellRect );
 }
end;

procedure TF_SeleArticle.bt_copieartClick(Sender: TObject);
var
  newcode : string;
  lt_Arg : Array [ 0..1 ] of string ;
  code_copie,fin : string;

begin
  if not gd_article.Datasource.DataSet.Active Then
    Exit ;

  lt_Arg [ 0 ] := 'cet article' ;

  // les 9 premiers caracteres sont a conserver en l'etat
  // alors que sur les 3 derniers, il faut supprimer les espaces
  with gd_article do
    Begin
      fin := trim(copy(Datasource.DataSet.FieldByName('ARTI_Clep').AsString,10,length(code_copie)));
      code_copie := copy(Datasource.DataSet.FieldByName('ARTI_Clep').AsString,1,9) + fin;

    end;

  // le code a copier ne doit pas depasser 10 caractere car on en rajoute 2
  if ( length(code_copie) <= 10 ) then
  begin
    M_Article.zq_code_copieart.Close;
    M_Article.zq_code_copieart.Params.ParamByName('Clep1').Value := code_copie;
    M_Article.zq_code_copieart.Open;

    if M_Article.zq_code_copieart.IsEmpty then
      begin
        newcode := 'Z'+ code_copie +'0';
        p_Copiearticle(newcode);
      end
    else // il y a deja des copies
    begin
      try
       newcode :=  'Z'+ code_copie;
       newcode := newcode + inttostr((strtoint(M_Article.zq_code_copieart.Fields[0].Value)+1));
      except
        // dans le cas ou l'on trouve un article deja 'Z'+article a copier
        // avec pour dernier caractere autre chose qu'un chiffre
        lt_Arg [ 1 ] := '';
        MessageDlg ( fs_RemplaceMsg ( U_CST_9305, lt_Arg ), mtWarning, [mbOK], 0 );
        exit;
      end;

      // le code article est un varchar(12) max
      if  (length(newcode) <= 12)   then
        p_Copiearticle(newcode)
      else
      begin
        lt_Arg [ 1 ] := 'Le nouveau code sera trop long.';
        MessageDlg ( fs_RemplaceMsg ( U_CST_9305, lt_Arg ), mtWarning, [mbOK], 0 );
      end;
    end;
  end
  else
  begin
    lt_Arg [ 1 ] := 'L''article ? copier a un code d?passant 10 caract?res.';
    MessageDlg ( fs_RemplaceMsg ( U_CST_9305, lt_Arg ), mtWarning, [mbOK], 0 );
  end;
end;


procedure TF_SeleArticle.p_Copiearticle(as_newcode: string);
begin
  // copie
  M_Article.zq_copieart.Close;
  M_Article.zq_copieart.Params.ParamByName('Cle1').Value := gd_article.Datasource.DataSet.FieldByName('ARTI_Clep').AsString;
  M_Article.zq_copieart.Params.ParamByName('Cle2').Value := as_newcode;
  M_Article.zq_copieart.ExecSQL;

  //raffraichissement ces donn?es et positionnement sur l'enregistrement
  gd_article.Datasource.DataSet.Refresh;
  gd_article.Datasource.DataSet.Locate('ARTI_Clep',as_newcode,[]);

  MessageDlg ( U_CST_9033, mtWarning, [mbOK], 0 );
end;

procedure TF_SeleArticle.F_FormDicoOnEraseFilter(const Dataset: TDataSet;
  const as_Champ: String);
begin
  ts_composition.Enabled := True ;

end;

procedure TF_SeleArticle.F_FormDicoDataSearching(const Dataset: TDataSet;
  const as_Champ: String);
begin
  ts_composition.Enabled := False ;

end;

//////////////////////////////////////////////////////////////////////////////////////
// Ev?nement : F_FormDicoDataOnSort
// Description : Tri quand on clique sur une fl?che
// Param?tres : Dataset: Les donn?es ? trier
//  as_Champ, as_TypeTri : Le champ et l'ordre de tri
//////////////////////////////////////////////////////////////////////////////////////
procedure TF_SeleArticle.F_FormDicoDataOnSort(Dataset: TDataSet;
  as_Champ, as_TypeTri: String);
var lbkm_Bookmark : TBookmarkStr ;
begin
  if  ( Dataset = gd_article.Datasource.DataSet )
  and ( Dataset is TIBQuery ) Then
  // Tri avec curseur sur le serveur
//  and ( ( Dataset as TIBQuery ).CursorLocation = clUseServer ) Then
    Begin
      try
        lbkm_Bookmark := Dataset.Bookmark ;
      Except
      End ;
      try
        p_EffaceOrderBy ( Dataset as TIBQuery );
        ( Dataset as TIBQuery ).SQL.Add ( 'ORDER BY ' + as_Champ + ' ' + as_TypeTri );
        Dataset.Open ;
      Except
        on e: Exception do
          f_GereException ( e, Dataset );
      End ;
      try
        Dataset.Bookmark := lbkm_Bookmark ;
      Except
      End ;
   end;
end;

//////////////////////////////////////////////////////////////////////////////////////
// proc?dure : p_EffaceOrderBy
// Description : Enl?ve le tri
// Param?tres : adat_MainQuery : Les donn?es ? trier
//////////////////////////////////////////////////////////////////////////////////////
procedure TF_SeleArticle.p_EffaceOrderBy ( const adat_MainQuery : TIBQuery );
begin
  adat_MainQuery.Close ;
  if ( pos ( 'ORDER BY', adat_MainQuery.SQL [ adat_MainQuery.SQL.Count - 1 ] ) > 0) Then
    adat_MainQuery.SQL.Delete ( adat_MainQuery.SQL.Count - 1 );
end;

procedure TF_SeleArticle.Loaded;
begin

  with DBSources.Add do
    Begin
      Table:='ARTICLE';
      Grid := gd_article;
      NavEdit:=nv_saisie;
      Navigator:=nv_navigator;
      Panels.Add.Panel:=pa_Saisie;
      Panels.Add.Panel:=Pa_chiffres;
    end;
  inherited Loaded;
end;

end.

